import os
import sys
from PIL import Image
import numpy as np

digit_dict = {"one":1, "two":2, "three":3, "four":4, "five":5, "six":6, "seven":7, "eight":8, "nine":9, "zero":0}


def load_training_data():
    final_pixval = []
    final_digit = []
    for filename in os.listdir("./train/"):
        if filename.endswith(".jpg"):
            im = Image.open("./train/"+filename, "r")
            #convert image to blackandwhite
            gray = im.convert('L')
            pix_val = list(gray.getdata())
            final_pixval.append(pix_val)
            filename_key = filename.split(".")[0]
            final_digit.append(digit_dict[filename_key])
    return (final_pixval, final_digit)

def load_test_data():
    final_pixval = []
    final_digit = []
    for filename in os.listdir("./test/"):
        if filename.endswith(".jpg"):
            im = Image.open("./test/"+filename, "r")
            gray = im.convert('L') 
            pix_val = list(gray.getdata())
            final_pixval.append(pix_val)
            filename_key = filename.split(".")[0]
            final_digit.append(digit_dict[filename_key])
    return (final_pixval, final_digit)


def get_train_data():
	tr_d  = load_training_data()
	training_inputs = [np.reshape(x, (256)) for x in tr_d[0]]
	training_results = [vectorized_result(y) for y in tr_d[1]]
	return training_inputs, training_results

def get_test_data():
	te_d = load_test_data()
	test_inputs = [np.reshape(x, (256)) for x in te_d[0]]
	test_data = [vectorized_result(y) for y in te_d[1]]
	return test_inputs, test_data

'''
def load_data_wrapper():
    tr_d, te_d = load_data_folder()
    training_inputs = [np.reshape(x, (256, 1)) for x in tr_d[0]]
    training_results = [vectorized_result(y) for y in tr_d[1]]
    training_data = zip(training_inputs, training_results)
    test_inputs = [np.reshape(x, (256, 1)) for x in te_d[0]]
    test_data = zip(test_inputs, te_d[1])
    return (training_data, test_data)
'''
def vectorized_result(j):
    e = np.zeros((10))
    e[j] = 1.0
    return e
